﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO.Ports;
using System.Configuration;
using System.Net.Sockets;

using System.IO;
using System.Threading;
using System.Diagnostics;

namespace GPSd
{
    public class WorkerProcessGPS : IDisposable
    {

        public event GPSEventHandler GPSChanged;
        public delegate void GPSEventHandler(object sender, string message);
        
        SerialPort sp = null;
        private bool disposed = false;
        TextReader streamreader = null;
        ThreadStart ts = null;
        Thread t = null;
        ASCIIEncoding ASCII = new ASCIIEncoding();
        string fakefile = "";

        public bool Running { get; set; }
        public WorkerProcessGPS()
        {
            
         
        }

        public void Start()
        {
            ts = new ThreadStart(run);
            t = new Thread(ts);
            t.Name = "GPS listener";
            t.IsBackground = true;
            Running = true;
            t.Start();
        }

        public void Stop()
        {
            Running = false;
            t.Abort();

         
        }

        private void run()
        {
            fakefile = ConfigurationSettings.AppSettings["fakefile"];
              if (fakefile != "")
              {
                   streamreader =  new StreamReader(fakefile);
                   while (Running)
                   {
                       Read();
                       Thread.Sleep(1000);
                   }
              }
              else
              {

                  string serialport = ConfigurationSettings.AppSettings["serialport"];

                  sp = new SerialPort(serialport);
                  sp.ReadBufferSize = 64;
                  sp.DataReceived += new SerialDataReceivedEventHandler(sp_DataReceived);

                  sp.Open();
              }
        }

        void sp_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            byte[] buffer = null;
            int bytesread = sp.Read(buffer, 0, sp.BytesToRead);
            if (bytesread>0)
            {
                pushit(ASCII.GetString(buffer));
            }
        }
        
        private void pushit(string message)
        {
            //Console.WriteLine(message);
            GPSChanged(this, message);
        }

        public void Read()
        {
            string line = "";
            
            if (streamreader!=null)
               line =streamreader.ReadLine();
            if (line.Length == 0)
            {
                if (streamreader != null)
                    streamreader.Close();
                
                streamreader = new StreamReader(fakefile);
            }
            else
            {
                pushit(line);
            }
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }
        public void Dispose(bool disposing)
        {
            if (disposed) return;
            if (disposing)
            {
               Debug.WriteLine("Dispose WorkerProcess GPS");

                

                // kill serial port
                if (sp != null)
                {
                    if (sp.IsOpen)
                    {
                        sp.DataReceived -= new SerialDataReceivedEventHandler(sp_DataReceived);
                        sp.Close();
                    }
                    sp.Dispose();
                }
            }
            disposed = true;
        }
    }
}